#define BAUD_ 2400
#define F_CPU 8000000

#include <util/delay.h>
#include <string.h>
#include <stdlib.h>
#include <avr/io.h>


void transmit(char data)
{
  while( !(UCSR0A & (1 << UDRE0))); // Wait until Tx is ready
  UDR0 = data;
}

char receive(void)
{
  while(!(UCSR0A & (1 << RXC0)));
  return UDR0;
}


int main()
{

  //Setup UART for 9600 baud
  UBRR0 = 103;
  UCSR0B |= (1 << TXEN0)|(1 << RXEN0); //enable tx & rx
  UCSR0C |= (1 << UCSZ00)|(1 << UCSZ01); // set 8-bit data
  
  
  //Setup pins for solenoid drivers
  //DDRB |= (1 << DDB2)|(1 << DDB1);
  DDRD |= (1 << DDD5)|(1 << DDD6);
  //Setup variable for uart data
  char input;
  
  while(1)
    {
      input = receive();
      
      if (input == 'a')
	{
	  //PORTB |= (1 << PORTB2);
	  PORTD |= (1 << PORTD5);
	  _delay_ms(1000);
	  PORTD &= ~(1 << PORTD5);
	  //PORTB &= ~(1 << PORTB2);
	  _delay_ms(50); //dead time
	  transmit('x');
	}
      else if (input == 'b')
	{
	  //PORTB |= (1 << PORTB1);
	  PORTD |= (1 << PORTD6);
	  _delay_ms(1000);
	  //PORTB &= ~(1 << PORTB1);
	  PORTD &= ~(1 << PORTD6);
	  _delay_ms(50); //dead time
	  transmit('y');
	}
      else
	{
	  input = 'f';
	  transmit(input);
	  transmit('f');
	  transmit('0');
	  transmit("0");
	  transmit(0);
	}
	  
    }
  
  
  return 0;
}

